#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GetTelephoneBill.h"
std::auto_ptr<Fish_GetTelephoneBill> Fish_GetTelephoneBill::msSingleton(nullptr);

int Fish_GetTelephoneBill::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GetTelephoneBillData* Fish_GetTelephoneBill::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GetTelephoneBillData>& Fish_GetTelephoneBill::GetMapData()
{
	return mMapData;
}

void Fish_GetTelephoneBill::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GetTelephoneBill.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GetTelephoneBillData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mDesc = element->Attribute("Desc");
		data.mBookIcon = element->Attribute("BookIcon");
		data.mGoTo = element->IntAttribute("GoTo");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GetTelephoneBill Loaded. Load Data:%u", mMapData.size());
}

void Fish_GetTelephoneBill::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GetTelephoneBill");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GetTelephoneBill");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GetTelephoneBillData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readString(L, "BookIcon", data.mBookIcon);
		LuaCfgHelper::readInt(L, "GoTo", data.mGoTo);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GetTelephoneBill Loaded. Load Data:%u", mMapData.size());
}

void Fish_GetTelephoneBill::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GetTelephoneBill* Fish_GetTelephoneBill::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GetTelephoneBill());
	}
	return msSingleton.get();
}

void Fish_GetTelephoneBill::Release()
{
	msSingleton.reset(nullptr);
}
